/******************************************************************************\
	FILE...........: Automata.h
	AUTHOR.........: Uriah   A. Alshevsky <uriaha@mail.ru>
			 Michael G. Raer      <mraer@mail.ru>
	DESCRIPTON.....: Describes classes of Automata.
	CLASSES........:  
	COPYRIGHT......: (c) 2002 RA_TEAM
	VERSION........: 1.0
	HISTORY........: DATE       COMMENT
									 ---------- --------------------------------------------------
					 12-01-2002 Created by Uriah Alshevsky & Michael Raer

\******************************************************************************/

/*==================================[ REDEFINITION DEFENCE ]==================*/
#ifndef __RA_Automata__
#define __RA_Automata__

/*==================================[ IMPORT  DECLARATIONS ]==================*/
#include "Automaton.h"



class CA1: public CAutomaton
{
public: 
	CA1():CAutomaton(" ",1)
	{
		stNames = new char*[4];
		stNames[0] = " ";
		stNames[1] = " ";
		stNames[2] = " ";
		stNames[3] = " ";
	}
	virtual void TA();
};


class CA2: public CAutomaton
{
public: 
	CA2():CAutomaton("   ",2)
	{
		stNames = new char*[4];
		stNames[0] = " ";
		stNames[1] = "  \" \"";
		stNames[2] = "  \" \"    1";
		stNames[3] = "  \" \"";
	}
	virtual void TA(); 
};


class CA3: public CAutomaton
{
public:
	CA3():CAutomaton("    ",3)
	{
		stNames = new char*[12];
		stNames[0]  = " ";
		stNames[1]  = " ";
		stNames[2]  = "   ";
		stNames[3]  = "   ";
		stNames[4]  = "     ";
		stNames[5]  = " .   ";
		stNames[6]  = " ";
		stNames[7]  = "    ";
		stNames[8]  = "   ";
		stNames[9]  = " ";
		stNames[10] = "  ";
		stNames[11] = "  ";
	}
	int Is_Closed() { return y_cur==0; }
	virtual void TA();
};


class CA4: public CAutomaton
{
public: 
	CA4():CAutomaton(" ",4)
	{
		stNames = new char*[2];
		stNames[0]  = " ";
		stNames[1]  = " ";
	}
	virtual void TA(); 
};


class CA5: public CAutomaton
{
public:
	CA5():CAutomaton(" ",5)
	{
		stNames = new char*[3];
		stNames[0]  = "   ";
		stNames[1]  = "      ";
		stNames[2]  = "   ";
	}
	int Is_Auto() { return y_cur==0; }
	virtual void TA();
};


class CA6: public CAutomaton
{
public: 
	CA6():CAutomaton("    ",6)
	{
		stNames = new char*[4];
		stNames[0]  = " ";
		stNames[1]  = " ";
		stNames[2]  = " ";
		stNames[3]  = " ";
	}
	virtual void TA(); 
};


class CA7: public CAutomaton
{
public: 
	CA7():CAutomaton("   ",7)
	{
		stNames = new char*[4];
		stNames[0]  = "  ";
		stNames[1]  = " ";
		stNames[2]  = " ";
		stNames[3]  = " ";
	}
	virtual void TA(); 
};


class CA8: public CAutomaton
{
public: 
	CA8():CAutomaton("      ",8)
	{
		stNames = new char*[2];
		stNames[0]  = "    ";
		stNames[1]  = " ";
	}
	virtual void TA(); 
};



/*==================================[ END REDEFINITION DEFENCE ]==============*/
#endif  //__RA_Automata__

/** (END OF FILE : Automata.h )*************************************************/
*/
