#include "stdafx.h"
#include <math.h>
#include "door.h"
#include "Automaton.h"
#include "Globals.h"

#define g_hPI 1.57079632679489661923132169163975

/////////////////////////////////////////////////////////////////////////////
// CDoor

CDoor::CDoor(double deltaAngle)
{
	m_DAngle = deltaAngle;
	m_Angle = 0;
}


CDoor::~CDoor()
{
}


void CDoor::Open()
{
	m_Angle += m_DAngle;
	if(m_Angle >= g_hPI)
	{
		CAutomaton::SendPubMsg(&Env, 3);
		m_Angle = g_hPI;
	}
}

void CDoor::Close()
{
	m_Angle -= m_DAngle;
	if(m_Angle <= 0) 
	{
		CAutomaton::SendPubMsg(&Env, 4);
		m_Angle = 0;
	}
}


BEGIN_MESSAGE_MAP(CDoor, CWnd)
	//{{AFX_MSG_MAP(CDoor)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDoor message handlers

void CDoor::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CPen pen(PS_SOLID, 2, RGB(0, 0, 0));
	
	int m_Dy = (int)(20 / (2 - cos(m_Angle)));
	int m_x = 39 - (int)(sin(m_Angle) * 38);
	CBrush brush(RGB(132,132,132));
	RECT window;
	window.left = 0;
	window.right = 40;
	window.top = 0;
	window.bottom = 40;
	
	dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(40, 40);
	dc.SetViewportExt(40, 40);
	dc.SetViewportOrg(0, 0);
	
	dc.SelectObject(pen);
	
	dc.FillRect(&window, &brush);
	dc.MoveTo(39, 10);
	dc.LineTo(39, 29);
	dc.LineTo(m_x, 19 + m_Dy);
	dc.LineTo(m_x, 20 - m_Dy);
	dc.LineTo(39, 10);

	ValidateRect(NULL);
	
	// Do not call CWnd::OnPaint() for painting messages
}
