/******************************************************************************\
    FILE...........: LogStr.cpp
    AUTHOR.........: Uriah   A. Alshevsky <uriaha@mail.ru>
                                     Michael G. Raer      <mraer@mail.ru>
    DESCRIPTON.....: Implements class CLogStr.
    CLASSES........: CLogStr
    COPYRIGHT......: (c) 2002 RA_TEAM
    VERSION........: 1.0
    HISTORY........: DATE       COMMENT
                                     ---------- --------------------------------------------------
                                     12-04-2002 Created by Michael Raer

\******************************************************************************/


/*==================================[ IMPORT DECLARATIONS ]===================*/
#include "StdAfx.h"
#include "String.h"
#include "StdLib.h"
#include "LogStr.h"
#include "z.h"
#include "x.h"
#include "m.h"




CLogStr::CLogStr(const char *aname, char anumber)
{
	y = 0;
	index_old = new char[5000];
	index_cur = new char[5000];
	index_old[0] = 0;
	index_cur[0] = 0;
	buffer[0] = 0;
	LOGGING = 0;
	M_LOGGING = 1;
	Z_LOGGING = 1;
	X_LOGGING = 1;
	M_SEND_LOGGING = 1;
	A_BEGINS_LOGGING = 1;
	A_TRANS_LOGGING = 1;
	A_ENDS_LOGGING = 1;
	A_ERRORS_LOGGING = 1;
	NO_REPEAT_LOGGING = 0;
	number = anumber;
	log_file = 0;
	strcpy(name, aname);

}

CLogStr::~CLogStr()
{
	if (log_file != 0) 
	{
		fprintf(log_file,"__________________________________________________");
		fclose(log_file);
		log_file = 0;
	}
	delete [] index_old;
	delete [] index_cur;
}

void CLogStr::SetLogging()
{
	char fname[256];
	char numStr[256];

	if (LOGGING == 0)
	{
		LOGGING = 1;
		if (number != 0)
		{
			strcpy(fname,"A");
			itoa(number, numStr, 10);
			strcat(fname, numStr);
		} else
		{
			strcpy(fname,name);
		}

		strcat(fname, ".log");
		if (!log_file)
		{
			log_file = fopen(fname, "w");
			if (number != 0)
				fprintf(log_file,"\n   \"%s\"(A%d)\n",name,number);
			else
				fprintf(log_file,"\n   \"%s\"\n",name);
			fprintf(log_file,"__________________________________________________\n\n");
		}
	}
}

void CLogStr::ReSetLogging()
{
	if (LOGGING == 1)
	{
		LOGGING = 0;
	}
}

char CLogStr::Is_Logging()
{
	return LOGGING;
}

char CLogStr::xL1()
{
	return (!strcmp(index_old,index_cur));
}

char CLogStr::xL2()
{
	return NO_REPEAT_LOGGING;
}

char CLogStr::xL3()
{
	return LOGGING;
}

void CLogStr::zL1()
{
	fprintf(log_file, "%s", buffer);
}

void CLogStr::zL2()
{
	fprintf(log_file, "       ...\n");
}

void CLogStr::zL3()
{
	char *temp;
	buffer[0] = 0;
	temp = index_old;
	index_old = index_cur;
	index_cur = temp;
	index_cur[0] = 0;
}

void CLogStr::zL4()
{
	buffer[0] = 0;
	index_old [0] = 0;
	index_cur [0] = 0;
}

void CLogStr::TA_Log()
{
	switch (y)
	{
		case 0:
			if (xL3())                   { zL4();					y = 2; }
			break;
		case 1:
			if ((xL1()&&xL2())&&xL3())   { zL3();					y = 1; }
			else
			if ((!xL1()||!xL2())&&xL3()) { zL1(); zL3();			y = 2; }
			else
			if (!xL3())                  { zL4();					y = 0; }
			break;
		case 2:
			if ((xL1()&&xL2())&&xL3())   { zL2(); zL3();			y = 1; }
			else
			if ((!xL1()||!xL2())&&xL3()) { zL1(); zL3();			y = 2; }
			else
			if (!xL3())                  { zL4();					y = 0; }
			break;
	}
}

char *const CLogStr::GetName()
{
	return (char *const) name;
}

char CLogStr::GetNumber()
{
	return number;
}

void CLogStr::MLogging(int msgNum, char b)
{
	if (b)
	{
		sprintf(buffer+strlen(buffer), "%d   %c m%d(%s) . \n", Counter, M_LOGGING_C, msgNum, MNames[msgNum]);
		sprintf(index_cur+strlen(index_cur),"M[%d][1]",msgNum);
	}
	else
	{
		sprintf(buffer+strlen(buffer), "%d   %c m%d(%s)  . \n", Counter, M_LOGGING_C, msgNum, MNames[msgNum]);
		sprintf(index_cur+strlen(index_cur),"M[%d][0]",msgNum);
	}
}

void CLogStr::ABeginsLogging(int y, char *stName)
{
	sprintf(buffer+strlen(buffer), "%d %c   A%d(%s)    %d(%s). \n", Counter, A_BEGINS_LOGGING_C, number, name, y, stName);
	sprintf(index_cur+strlen(index_cur),"AB[%d]",y);
}

void CLogStr::AEndsLogging(int y, char *stName)
{
	sprintf(buffer+strlen(buffer), "%d %c   A%d(%s)     %d(%s). \n", Counter, A_ENDS_LOGGING_C, number, name, y, stName);
	sprintf(index_cur+strlen(index_cur), "AE[%d]",y);
}

void CLogStr::ATransLogging(int y1, int y2, char *stName1, char *stName2)
{
	sprintf(buffer+strlen(buffer), "%d   %c A%d(%s)    %d(%s)  %d(%s). \n", Counter, A_TRANS_LOGGING_C, number, name, y1, stName1, y2, stName2);
	sprintf(index_cur+strlen(index_cur), "AT[%d][%d]",y1,y2);
}

void CLogStr::AErrorsLogging(int y)
{
	sprintf(buffer+strlen(buffer), "%d   %c    A%d(%s).    - %d. \n", Counter, A_ERRORS_LOGGING_C, number, name, y);
	sprintf(index_cur+strlen(index_cur), "ER[%d]",y);
}

void CLogStr::ZLogging (int zNum)
{
	sprintf(buffer+strlen(buffer), "%d   %c z%d(%s). \n", Counter, Z_LOGGING_C, zNum, ZNames[zNum]);
	sprintf(index_cur+strlen(index_cur), "Z[%d]",zNum);
}

void CLogStr::XLogging (int xNum, char b)
{
	if (b)
		sprintf(buffer+strlen(buffer), "%d   %c x%d(%s) -  %d. \n", Counter, X_LOGGING_C, xNum, XNames[xNum], b);
	else
		sprintf(buffer+strlen(buffer), "%d   %c x%d(%s) -  %d. \n", Counter, X_LOGGING_C, xNum, XNames[xNum], b);
	sprintf(index_cur+strlen(index_cur), "X[%d][%d]",xNum,b);

}

void CLogStr::MSendPubLogging (CLogStr *a, int msgNum)
{
	if (a->number != 0)
	{
		sprintf(a->buffer+strlen(a->buffer), "%d   %c A%d(%s)   m%d(%s)    . \n", Counter, M_SEND_LOGGING_C, a->number, a->name, msgNum, MNames[msgNum]);
		sprintf(a->index_cur+strlen(a->index_cur),"MSB[%d]",msgNum);
	}
	else
		fprintf(a->log_file, "%d   %c %s   m%d(%s)    . \n", Counter, M_SEND_LOGGING_C, a->name, msgNum, MNames[msgNum]);
}

void CLogStr::MSendPrvLogging (CLogStr *a, int msgNum)
{
	if (a->number != 0)
	{
		sprintf(a->buffer+strlen(a->buffer), "%d   %c A%d(%s)   m%d(%s)  A%d(%s). \n", Counter, M_SEND_LOGGING_C, a->number, a->name, msgNum, MNames[msgNum], number, name);
		sprintf(a->index_cur+strlen(a->index_cur),"MSV[%d][%d]",msgNum, number);
	}
	else
		fprintf(a->log_file, "%d   %c %s   m%d(%s)  A%d(%s). \n", Counter, M_SEND_LOGGING_C, a->name, msgNum, MNames[msgNum], number, name);
}
/** (END OF FILE : LogStr.cpp )*************************************************/