/******************************************************************************\
    FILE...........: LogStr.h
    AUTHOR.........: Uriah   A. Alshevsky <uriaha@mail.ru>
                     Michael G. Raer      <mraer@mail.ru>
    DESCRIPTON.....: Describes class CLogStr.
    CLASSES........: CLogStr
    COPYRIGHT......: (c) 2002 RA_TEAM
    VERSION........: 1.0
    HISTORY........: DATE       COMMENT
                     ---------- --------------------------------------------------
                     12-01-2002 Created by Uriah Alshevsky & Michael Raer
                     01-29-2003 Events renamed into Messages by Uriah

\******************************************************************************/

/*==================================[ REDEFINITION DEFENCE ]==================*/
#ifndef __RA_CLogStr__
#define __RA_CLogStr__

/*==================================[ IMPORT DECLARATIONS ]===================*/
#include <stdio.h>

//    
//   
extern long int Counter;

//  ...
enum 
{
	M_LOGGING_C          = '?', // ...  
	Z_LOGGING_C          = '<', // ... 
	X_LOGGING_C          = '>', // ...  
	M_SEND_LOGGING_C     = '!', // ... 
	A_BEGINS_LOGGING_C   = '{', // ...  
	A_TRANS_LOGGING_C    = 'T', // ...     
	A_ENDS_LOGGING_C     = '}', // ...  
	A_ERRORS_LOGGING_C   = 'E'  // ...    
};


/******************************************************************************\
	CLASS.........: CLogStr
	DESCRIPTION...:   
\******************************************************************************/
class CLogStr
{
protected:
  
	char number;       //   
	char name[256];    //   
	FILE *log_file;    //      
	char LOGGING;      //   ?

	char buffer[5000]; //    
	char *index_old;   //     
	char *index_cur;   //     
	
	int y;             // ,    

	//     
	char xL1(); //      
	char xL2(); //   
	char xL3(); //   

	//     
	void zL1(); //   
	void zL2(); //  
	void zL3(); //   .    .   
	void zL4(); //   .     

public:

	//   ...
	char M_LOGGING;         // ...  
	char Z_LOGGING;         // ... 
	char X_LOGGING;         // ...  
	char M_SEND_LOGGING;    // ... 
	char A_BEGINS_LOGGING;  // ...  
	char A_TRANS_LOGGING;   // ...     
	char A_ENDS_LOGGING;    // ...  
	char A_ERRORS_LOGGING;  // ...    
	char NO_REPEAT_LOGGING; //    ?


	CLogStr(const char *aname, char anumber);
	~CLogStr();

	void SetLogging();      //   
	void ReSetLogging();    //  
	char Is_Logging();      //   ?

	void TA_Log();          //   

	char *const GetName();  //      
	char GetNumber();       //      


	//    
	void MLogging(int msgNum, char b);

	//    
	void XLogging (int xNum, char b);

	//   	
	void ZLogging (int zNum);

	//    
	void ABeginsLogging (int y, char *stName);

	//    
	void AEndsLogging (int y, char *stName);

	//      
	void ATransLogging(int y1, int y2, char *stName1, char *stName2);
	
	//      
	void AErrorsLogging(int y);

	//      
	static void MSendPubLogging (CLogStr *a, int msgNum);

	//     
	void MSendPrvLogging (CLogStr *a, int msgNum);
};

/*==================================[ END REDEFINITION DEFENCE ]==============*/
#endif  //__RA_CLogStr__

/** (END OF FILE : LogStr.h )*************************************************/
