// LoggingOptions.cpp : implementation file
//

#include "stdafx.h"
#include "TurnstileDlg.h"
#include "LoggingOptions.h"
#include "StdIO.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CTurnstileDlg * g_Dlg;
/////////////////////////////////////////////////////////////////////////////
// CLoggingOptions dialog


CLoggingOptions::CLoggingOptions(CWnd* pParent /*=NULL*/)
	: CDialog(CLoggingOptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoggingOptions)
	//}}AFX_DATA_INIT
}


void CLoggingOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoggingOptions)
	DDX_Control(pDX, IDC_CHECK_MSEND, m_MSend);
	DDX_Control(pDX, IDC_CHECK_M, m_M);
	DDX_Control(pDX, IDC_CHECK_STEP, m_Debug);
	DDX_Control(pDX, IDC_STATIC_A_NAME, m_AName);
	DDX_Control(pDX, IDC_TAB_A_NAME, m_Tab);
	DDX_Control(pDX, IDC_CHECK_LOG, m_ALog);
	DDX_Control(pDX, IDC_CHECK_CHANGES, m_AChanges);
	DDX_Control(pDX, IDC_CHECK_Z, m_Z);
	DDX_Control(pDX, IDC_CHECK_X, m_X);
	DDX_Control(pDX, IDC_CHECK_ERRORS, m_Errors);
	DDX_Control(pDX, IDC_CHECK_ATRANS, m_ATrans);
	DDX_Control(pDX, IDC_CHECK_AENDS, m_AEnds);
	DDX_Control(pDX, IDC_CHECK_ABEGINS, m_ABegins);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLoggingOptions, CDialog)
	//{{AFX_MSG_MAP(CLoggingOptions)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB_A_NAME, OnSelchangeTabAName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoggingOptions message handlers

void CLoggingOptions::OnOK() 
{
	RestoreValues(m_CurSel);
	CAutomaton * tmp;
	int i;
	for(i = 0; i < STR_NUM; i++)
	{
		// Common parametres
		g_Str[i]->NO_REPEAT_LOGGING = m_Param[i].Ch;
		g_Str[i]->M_SEND_LOGGING    = m_Param[i].SM;

		if (m_Param[i].Log) 
			g_Str[i]->SetLogging();
		else
			g_Str[i]->ReSetLogging();

		// CAutomat parametres
		if(g_Str[i]->GetNumber())
		{
			tmp = (CAutomaton *)(g_Str[i]);
			tmp->A_BEGINS_LOGGING = m_Param[i].AB;
			tmp->A_ENDS_LOGGING   = m_Param[i].AE;
			tmp->A_TRANS_LOGGING  = m_Param[i].AT;
			tmp->A_ERRORS_LOGGING = m_Param[i].Er;
			tmp->M_LOGGING        = m_Param[i].M;
			tmp->X_LOGGING        = m_Param[i].X;
			tmp->Z_LOGGING        = m_Param[i].Z;
		}
	}

	g_Dlg->m_Debug.ShowWindow(m_Debug.GetCheck() ? SW_SHOW : SW_HIDE);
	g_Dlg->m_SDebug.ShowWindow(m_Debug.GetCheck() ? SW_SHOW : SW_HIDE);

	CDialog::OnOK();
}

BOOL CLoggingOptions::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Creating CTabCtrl
	char name[256];
	TCITEM tcItem;
	tcItem.mask = TCIF_TEXT;

	int i;
	for(i = 0; i < STR_NUM; i++)
	{
		if(g_Str[i]->GetNumber())
		{
			sprintf(name,"A%d",g_Str[i]->GetNumber());
			tcItem.pszText = _T(name);
		}
		else
		tcItem.pszText = _T(g_Str[i]->GetName());
		m_Tab.InsertItem(i, &tcItem);
	}
	
	//Set values to m_Param array
	CAutomaton * tmp;
	for(i = 0; i < STR_NUM; i++)
	{
		m_Param[i].Ch  = g_Str[i]->NO_REPEAT_LOGGING;
		m_Param[i].SM  = g_Str[i]->M_SEND_LOGGING;
		m_Param[i].Log = g_Str[i]->Is_Logging();
		if(g_Str[i]->GetNumber())
		{
			tmp = (CAutomaton *)(g_Str[i]);
			m_Param[i].AB = tmp->A_BEGINS_LOGGING;
			m_Param[i].AE = tmp->A_ENDS_LOGGING;
			m_Param[i].AT = tmp->A_TRANS_LOGGING;
			m_Param[i].Er = tmp->A_ERRORS_LOGGING;
			m_Param[i].M  = tmp->M_LOGGING;
			m_Param[i].X  = tmp->X_LOGGING;
			m_Param[i].Z  = tmp->Z_LOGGING;
		}
	}

	m_Debug.SetCheck(g_Dlg->m_Debug.IsWindowVisible( ));
	// Set current values
	SetValues(0);
	m_Tab.SetCurSel(0);
	m_CurSel = 0;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CLoggingOptions::SetValues(int index)
{
 	m_AName.SetWindowText(g_Str[index]->GetName());

	m_ABegins.ShowWindow(g_Str[index]->GetNumber() ? SW_SHOW : SW_HIDE);
	m_AEnds.ShowWindow(g_Str[index]->GetNumber() ? SW_SHOW : SW_HIDE);
	m_ATrans.ShowWindow(g_Str[index]->GetNumber() ? SW_SHOW : SW_HIDE);
	m_Errors.ShowWindow(g_Str[index]->GetNumber() ? SW_SHOW : SW_HIDE);
	m_AChanges.ShowWindow(g_Str[index]->GetNumber() ? SW_SHOW : SW_HIDE);
	m_M.ShowWindow(g_Str[index]->GetNumber() ? SW_SHOW : SW_HIDE);
	m_X.ShowWindow(g_Str[index]->GetNumber() ? SW_SHOW : SW_HIDE);
	m_Z.ShowWindow(g_Str[index]->GetNumber() ? SW_SHOW : SW_HIDE);
//	this->m_Turnstile.ShowWindow(g_Str[index]->GetNumber() ? SW_HIDE : SW_SHOW);
 	
	m_ABegins.SetCheck(m_Param[index].AB);
 	m_AEnds.SetCheck(m_Param[index].AE);
 	m_ATrans.SetCheck(m_Param[index].AT);
 	m_Errors.SetCheck(m_Param[index].Er);
 	m_MSend.SetCheck(m_Param[index].SM);
 	m_AChanges.SetCheck(m_Param[index].Ch);
 	m_M.SetCheck(m_Param[index].M);
 	m_X.SetCheck(m_Param[index].X);
 	m_Z.SetCheck(m_Param[index].Z);
 	m_ALog.SetCheck(m_Param[index].Log);
}


void CLoggingOptions::RestoreValues(int index)
{
 	m_Param[index].AB  =  m_ABegins.GetCheck();
 	m_Param[index].AE  =    m_AEnds.GetCheck();
 	m_Param[index].AT  =   m_ATrans.GetCheck();
 	m_Param[index].Er  =   m_Errors.GetCheck();
 	m_Param[index].SM  =    m_MSend.GetCheck();
 	m_Param[index].Ch  = m_AChanges.GetCheck();
 	m_Param[index].M   =        m_M.GetCheck();
 	m_Param[index].X   =        m_X.GetCheck();
 	m_Param[index].Z   =        m_Z.GetCheck();
 	m_Param[index].Log =     m_ALog.GetCheck();
}


void CLoggingOptions::OnSelchangeTabAName(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int l_CurSel = m_Tab.GetCurSel();
	if(l_CurSel != m_CurSel)
	{
		RestoreValues(m_CurSel);
		SetValues(l_CurSel);
		m_CurSel = l_CurSel;
	}
	*pResult = 0;
}
