// TurnstileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Turnstile.h"
#include "TurnstileDlg.h"
#include "Globals.h"
#include "Automaton.h"
#include "LoggingOptions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern long int Counter;

/////////////////////////////////////////////////////////////////////////////
// CTurnstileDlg dialog

CTurnstileDlg::CTurnstileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTurnstileDlg::IDD, pParent),
	  m_Door(0.02)
{
	//{{AFX_DATA_INIT(CTurnstileDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTurnstileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTurnstileDlg)
	DDX_Control(pDX, IDC_STATIC_DEBUG, m_SDebug);
	DDX_Control(pDX, IDC_EDIT_DEBUG, m_Debug);
	DDX_Control(pDX, IDC_PANEL_BUTTON_CARD, m_InsertCard);
	DDX_Control(pDX, IDC_CONTROL_BUTTON_OPEN, m_ControlOpen);
	DDX_Control(pDX, IDC_CONTROL_CHECK_SELFCONTROL, m_SelfControl);
	DDX_Control(pDX, IDC_ATTENTION, m_Attention);
	DDX_Control(pDX, IDC_SERVER_EDIT, m_ServerCard);
	DDX_Control(pDX, IDC_PANEL_EDIT_CARD, m_PanelCard);
	DDX_Control(pDX, IDC_PANEL_EDIT_CREDITS, m_PanelCredits);
	DDX_Control(pDX, IDC_PANEL_OPEN, m_PanelOpened);
	DDX_Control(pDX, IDC_PANEL_CLOSED, m_PanelClosed);
	DDX_Control(pDX, IDC_CONTROL_LIGHT, m_ControlLight);
	DDX_Control(pDX, IDC_TURNSTILE, m_TurnstilePicture);
	DDX_Control(pDX, IDC_CHECK_TURNSTILE_LIGHT5, m_Light5);
	DDX_Control(pDX, IDC_CHECK_TURNSTILE_LIGHT4, m_Light4);
	DDX_Control(pDX, IDC_CHECK_TURNSTILE_LIGHT3, m_Light3);
	DDX_Control(pDX, IDC_CHECK_TURNSTILE_LIGHT2, m_Light2);
	DDX_Control(pDX, IDC_CHECK_TURNSTILE_LIGHT1, m_Light1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTurnstileDlg, CDialog)
	//{{AFX_MSG_MAP(CTurnstileDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PANEL_BUTTON_CARD, OnPanelButtonCard)
	ON_BN_CLICKED(IDC_CHECK_TURNSTILE_LIGHT1, OnCheckTurnstileLight1)
	ON_BN_CLICKED(IDC_CHECK_TURNSTILE_LIGHT2, OnCheckTurnstileLight2)
	ON_BN_CLICKED(IDC_CHECK_TURNSTILE_LIGHT3, OnCheckTurnstileLight3)
	ON_BN_CLICKED(IDC_CHECK_TURNSTILE_LIGHT4, OnCheckTurnstileLight4)
	ON_BN_CLICKED(IDC_CHECK_TURNSTILE_LIGHT5, OnCheckTurnstileLight5)
	ON_BN_CLICKED(IDC_SERVER_BUTTON_ACCEPT, OnServerButtonAccept)
	ON_BN_CLICKED(IDC_SERVER_BUTTON_REJECT, OnServerButtonReject)
	ON_BN_CLICKED(IDC_SERVER_BUTTON_BLACK, OnServerButtonBlack)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_OPTIONS, OnOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// The one and only Accelerator

HACCEL g_hAccel;

/////////////////////////////////////////////////////////////////////////////
// The one and only Application

extern CTurnstileApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTurnstileDlg message handlers

BOOL CTurnstileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_Door.CreateEx(WS_EX_TOPMOST,
					NULL, 
					NULL, 
					WS_CHILD | 
					WS_CLIPCHILDREN |
					WS_CLIPSIBLINGS |
					WS_VISIBLE,
					45,
					68,
					40,
					40,
					m_TurnstilePicture.m_hWnd,
					NULL
					);
	
	m_PanelCredits.SetWindowText("0");

	KillTimer(AUTOMATA_CIRCLE_ID);
	if(!SetTimer(AUTOMATA_CIRCLE_ID, AUTOMATA_CIRCLE_ELAPSE, NULL))
	{
		MessageBox("Unable to create the timer!");
	}; 

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTurnstileDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTurnstileDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTurnstileDlg::OnPanelButtonCard() 
{
	// TODO: Add your control notification handler code here
	CAutomaton::SendPubMsg(&Env, 11);
}

BOOL CTurnstileDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(TranslateAccelerator(m_hWnd, g_hAccel, pMsg))
		return 1;
	else
		return CDialog::PreTranslateMessage(pMsg);
}

void CTurnstileDlg::OnCheckTurnstileLight1() 
{
	// TODO: Add your control notification handler code here
	g_x1 = !g_x1;
	m_Light1.SetCheck(g_x1);
}

void CTurnstileDlg::OnCheckTurnstileLight2() 
{
	// TODO: Add your control notification handler code here
	g_x2 = !g_x2;
	m_Light2.SetCheck(g_x2);
}

void CTurnstileDlg::OnCheckTurnstileLight3() 
{
	// TODO: Add your control notification handler code here
	g_x3 = !g_x3;
	m_Light3.SetCheck(g_x3);
}

void CTurnstileDlg::OnCheckTurnstileLight4() 
{
	// TODO: Add your control notification handler code here
	g_x4 = !g_x4;
	m_Light4.SetCheck(g_x4);
}

void CTurnstileDlg::OnCheckTurnstileLight5() 
{
	// TODO: Add your control notification handler code here
	g_x5 = !g_x5;
	m_Light5.SetCheck(g_x5);
}

void CTurnstileDlg::OnServerButtonAccept() 
{
	// TODO: Add your control notification handler code here
	g_Server = 1;
}

void CTurnstileDlg::OnServerButtonReject() 
{
	// TODO: Add your control notification handler code here
	g_Server = 2;
}

void CTurnstileDlg::OnServerButtonBlack() 
{
	// TODO: Add your control notification handler code here
	g_Server = 3;
}

void CTurnstileDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	switch(nIDEvent)
	{
	case(AUTOMATA_CIRCLE_ID):
		RunAuta();
	break;
	case(DOOR_OPEN_ID):
		m_Door.Open();
		m_Door.Invalidate();
	break;
	case(DOOR_CLOSE_ID):
		m_Door.Close();
		m_Door.Invalidate();
	break;
	case(ATTENTION_ID):
		KillTimer(ATTENTION_ID);
		CAutomaton::SendPubMsg(&Env, 6);
	break;
	case(LIGHT_CLOSED_ID):
		KillTimer(LIGHT_CLOSED_ID);
		CAutomaton::SendPubMsg(&Env, 7);
	break;
	case(HANDCART_ID):
		KillTimer(HANDCART_ID);
		CAutomaton::SendPubMsg(&Env, 12);
	break;
	}
	
	CDialog::OnTimer(nIDEvent);
}


void CTurnstileDlg::OnDestroy() 
{
	KillTimer(AUTOMATA_CIRCLE_ID);
	
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
}

void CTurnstileDlg::OnOptions() 
{
	// TODO: Add your control notification handler code here
	CLoggingOptions dlg;
	dlg.DoModal();
}
