// TurnstileDlg.h : header file
//

#if !defined(AFX_TURNSTILEDLG_H__4F7AC54A_232F_11D7_AA1E_BB06D692D620__INCLUDED_)
#define AFX_TURNSTILEDLG_H__4F7AC54A_232F_11D7_AA1E_BB06D692D620__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Resource.h"
#include "Door.h"

/////////////////////////////////////////////////////////////////////////////
// Constants

#define DOOR_OPEN_ID      1
#define DOOR_CLOSE_ID     2
#define ATTENTION_ID      3
#define LIGHT_CLOSED_ID   4
#define AUTOMATA_CIRCLE_ID 5
#define HANDCART_ID        6
#define DOOR_OPEN_ELAPSE      50
#define DOOR_CLOSE_ELAPSE     50
#define ATTENTION_ELAPSE      2000
#define LIGHT_CLOSED_ELAPSE   2000
#define HANDCART_ELAPSE       5000
#define AUTOMATA_CIRCLE_ELAPSE 100

/////////////////////////////////////////////////////////////////////////////
// CTurnstileDlg dialog

class CTurnstileDlg : public CDialog
{
// Construction
public:
	CTurnstileDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTurnstileDlg)
	enum { IDD = IDD_TURNSTILE_DIALOG };
	CStatic	m_SDebug;
	CEdit	m_Debug;
	CButton	m_InsertCard;
	CButton	m_ControlOpen;
	CButton	m_SelfControl;
	CStatic	m_Attention;
	CEdit	m_ServerCard;
	CEdit	m_PanelCard;
	CEdit	m_PanelCredits;
	CStatic	m_PanelOpened;
	CStatic	m_PanelClosed;
	CStatic	m_ControlLight;
	CStatic	m_TurnstilePicture;
	CButton	m_Light5;
	CButton	m_Light4;
	CButton	m_Light3;
	CButton	m_Light2;
	CButton	m_Light1;
	CDoor	m_Door;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTurnstileDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTurnstileDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPanelButtonCard();
	afx_msg void OnCheckTurnstileLight1();
	afx_msg void OnCheckTurnstileLight2();
	afx_msg void OnCheckTurnstileLight3();
	afx_msg void OnCheckTurnstileLight4();
	afx_msg void OnCheckTurnstileLight5();
	afx_msg void OnServerButtonAccept();
	afx_msg void OnServerButtonReject();
	afx_msg void OnServerButtonBlack();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnOptions();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TURNSTILEDLG_H__4F7AC54A_232F_11D7_AA1E_BB06D692D620__INCLUDED_)
