/******************************************************************************\
	FILE...........: z.cpp
	AUTHOR.........: Michael G. Raer      <mraer@mail.ru>
	DESCRIPTON.....: Implements Outputs
	COPYRIGHT......: (c) 2002 RA_TEAM
	VERSION........: 1.01A
	HISTORY........: DATE       COMMENT
			 ---------- --------------------------------------------------
			 12-04-2002 Created by Michael Raer
                         01-13-2003 Filled & fixed by Uriah

\******************************************************************************/

/*==================================[ IMPORT  DECLARATIONS ]==================*/
#include "StdAfx.h"
#include "z.h"
#include "Turnstile.h"
#include "TurnstileDlg.h"
#include "Globals.h"

extern CTurnstileDlg * g_Dlg;
extern CTurnstileApp theApp;

char *ZNames[] =
{
	"",//z0
	"   ",//z1
	"   ",//z2
	"   ",//z3
	"   ",//z4
	"    ",//z5
	" ",//z6
	" ",//z7
	"     \" \"",//z8
	"  \" \"",//z9
	"  \" \"",//z10
	"  \" \"",//z11
	"  \" \"",//z12
	"     ",//z13
	"",//z14	
	"",//z15	
	"  \" \"",//z16	
	"  \" \"",//z17
	"     ",//z18		
	"  ",//z19
	"   ",//z20
 	"  ",//z21	
	"    ",//z22	
	"     ",//z23	
	"    " //z24
};


void z1()
{
	g_Dlg->KillTimer(DOOR_OPEN_ID);
	if(!g_Dlg->SetTimer(DOOR_OPEN_ID, DOOR_OPEN_ELAPSE, NULL))
	{
		g_Dlg->MessageBox("Unable to create the timer!");
	}; 
}

void z2()
{
	 g_Dlg->KillTimer(DOOR_OPEN_ID);
}

void z3()
{
	g_Dlg->KillTimer(DOOR_CLOSE_ID);
	if(!g_Dlg->SetTimer(DOOR_CLOSE_ID, DOOR_CLOSE_ELAPSE, NULL))
	{
		g_Dlg->MessageBox("Unable to create the timer!");
	};  
}

void z4()
{
	 g_Dlg->KillTimer(DOOR_CLOSE_ID);
}

void z5()
{
	g_Dlg->KillTimer(ATTENTION_ID);
	if(!g_Dlg->SetTimer(ATTENTION_ID, ATTENTION_ELAPSE, NULL))
	{
		g_Dlg->MessageBox("Unable to create the timer!");
	};
}

void z6()
{
	 g_Dlg->m_Attention.SetIcon(theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_ATTENTION_ON)));
}

void z7()
{
 	 g_Dlg->m_Attention.SetIcon(theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_ATTENTION_OFF)));
}

void z8()
{
	g_Dlg->KillTimer(LIGHT_CLOSED_ID);
	if(!g_Dlg->SetTimer(LIGHT_CLOSED_ID, LIGHT_CLOSED_ELAPSE, NULL))
	{
		g_Dlg->MessageBox("Unable to create the timer!");
	}; 
}

void z9()
{
	g_Dlg->m_PanelOpened.SetIcon(theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_OPENED_ON)));
}

void z10()
{
	g_Dlg->m_PanelOpened.SetIcon(theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_OPENED_OFF)));
}

void z11()
{
	g_Dlg->m_PanelClosed.SetIcon(theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_CLOSED_ON)));
}

void z12()
{
	g_Dlg->m_PanelClosed.SetIcon(theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_CLOSED_OFF)));
}

void z13()
{
	 int ID = g_Dlg->m_PanelCredits.GetDlgCtrlID();
	 UINT tmp = g_Dlg->GetDlgItemInt(ID, NULL, FALSE);
	 tmp--;
	 g_Dlg->SetDlgItemInt(ID, tmp, FALSE);
}

void z16()
{
	 g_Dlg->m_ControlLight.SetIcon(theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_LIGHT_ON)));
}

void z17()
{
	 g_Dlg->m_ControlLight.SetIcon(theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_LIGHT_OFF)));
}

void z18()
{
	 int ID = g_Dlg->m_PanelCredits.GetDlgCtrlID();
	 UINT tmp = g_Dlg->GetDlgItemInt(ID, NULL, FALSE);
	 tmp++;
	 g_Dlg->SetDlgItemInt(ID, tmp, FALSE);
}

void z19()
{
	 g_Dlg->m_PanelCard.EnableWindow(FALSE);
	 g_Dlg->m_InsertCard.EnableWindow(FALSE);
}

void z20()
{
	 g_Dlg->GetDlgItemInt(g_Dlg->m_PanelCard.GetDlgCtrlID(), &g_x11, FALSE);
}

void z21()
{
	 g_Dlg->m_PanelCard.EnableWindow(TRUE);
	 g_Dlg->m_InsertCard.EnableWindow(TRUE);
}

void z22()
{
	 g_Dlg->m_PanelCard.SetWindowText(NULL);
	 g_Dlg->m_PanelCard.EnableWindow(TRUE);
	 g_Dlg->m_InsertCard.EnableWindow(TRUE);
}

void z23()
{
	 g_Server = 0;
	 CString tmp;
	 g_Dlg->m_PanelCard.GetWindowText(tmp);
	 g_Dlg->m_ServerCard.SetWindowText((LPCTSTR)tmp);
}

void z24()
{
	g_Dlg->KillTimer(HANDCART_ID);
	if(!g_Dlg->SetTimer(HANDCART_ID, HANDCART_ELAPSE, NULL))
	{
		g_Dlg->MessageBox("Unable to create the timer!");
	};
}

void (*z_arr[])() = 
{
	0,
	z1,
	z2,
	z3,
	z4,
	z5,
	z6,
	z7,
	z8,
	z9,
	z10,
	z11,
	z12,
	z13,
	0,
	0,
	z16,
	z17,
	z18,
	z19,
	z20,
	z21,
	z22,
	z23,
	z24
};


/** (END OF FILE : z.cpp )*******************************************************/
